#include <stdio.h>
#include <stdlib.h>

#define ElementSize sizeof(int)

//int array
struct size
{
	int bytes, elements;
};

void error(int code, char *text)
{
	fprintf(stderr, "%s\n", text);
	exit(code);
}

int decode(char *s)
{
	int result = 0;
	while((*s >= '0')&&(*s <= '9'))
		result = result * 10 + *s++ - '0';
	switch(*s++)
	{
		#define p(letter, i, ni) case letter:if(*s == 0) return result * ni; else if((*s == 'i')&&(*(s + 1) == 0)) return result * i; else error(2,"int parse error");break

		p('K', 1024, 1000);
		p('M', 1024*1024, 1000*1000);
		#undef p
		case 0:
			return result;
		default:
				error(2, "int parse error");
	}
}

#include <inttypes.h>
uint64_t TimeValue=0;
uint64_t time_RDTSC()
{union ticks
{uint64_t tx;
struct dblword { uint32_t tl,th; } dw; // little endian
}t;
asm("rdtsc\n": "=a"(t.dw.tl),"=d"(t.dw.th));
return t.tx;
} // for x86 only!
void time_start() { TimeValue=time_RDTSC(); }
uint64_t time_stop() { return time_RDTSC()-TimeValue; }

int main(int argc, char **argv)
{

	if(argc != 4)
		error(1, " blocksize offset N");
	int Offset = decode(argv[2])/ElementSize;
	int N = decode(argv[3]);
	int BlockSize = decode(argv[1])/N/ElementSize;
	
//	int array[Offset * N];
//	printf("%d\n", ElementSize * Offset * N);
	int *array = malloc(ElementSize * Offset * N);
	
	int LoopBlock, LoopElement;
	for(LoopBlock = 0; LoopBlock < N - 1; LoopBlock++)
		for(LoopElement = 0; LoopElement < BlockSize; LoopElement++)
			array[LoopBlock*Offset + LoopElement] = (LoopBlock+1)*Offset + LoopElement;
	for(LoopElement = 0; LoopElement < BlockSize-1; LoopElement++)
		array[(N-1)*Offset + LoopElement] = LoopElement + 1;
	array[(N-1)*Offset + BlockSize - 1] = 0;
	
	time_start();

	int position = array[0];
	while(position != 0)
	{
//		printf("%d ", position);
		position = array[position];
	}
	unsigned long long int time = time_stop();

//	printf("\n");
//	printf("%de*%dbl*%db %de*%db %dbl %lld \n", BlockSize, N, ElementSize, Offset, ElementSize, N, time);
//	Черно-красное дерево
	printf("%d %d %d %llu \n", BlockSize*N*ElementSize, Offset*ElementSize, N, time);
	free(array);
	return 0;
}
