#!/bin/bash

ITEM="iskeusz"
DIR="iskeusz"
BLOCKSIZE=32Ki
OFFSET=1Mi
MAXN=16
AT=10000

rm -rf results/data/$DIR
mkdir -p results/data/$DIR

for N in `seq 1 $MAXN`;do
	MIN[$N]=-1;
	ALL[$N]=0;
done

for i in `seq 1 $AT`;do
	for N in `seq 1 $MAXN`;do
		RES=$(taskset  0x00000001 ./main $BLOCKSIZE $OFFSET $N | awk '{print $4}');
		if [ ${MIN[N]} -eq -1 ] || [ ${MIN[N]} -ge $RES ] ;then
			MIN[$N]=$RES;
		fi;
		ALL[$N]=$((ALL[N]+RES));
	done;
	echo -en "\r$i / $AT"
done
echo

for N in `seq 1 $MAXN`;do
	echo $N ${MIN[N]} $((ALL[N] / AT));
done > results/data/$DIR/graph.txt
echo "$ITEM, Blocksize = $BLOCKSIZE, Offset = $OFFSET, Attempts = $AT" > results/data/$DIR/info.txt
